SystemOrganization addCategory: #'Glamour-Mondrian-Presentations'!

GLMPresentation subclass: #GLMMondrianPresentation
	instanceVariableNames: 'painting view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Mondrian-Presentations'!

!GLMMondrianPresentation commentStamp: 'tg 9/20/2009 14:28' prior: 0!
A GLMMondrianPresentation delegates the actual presenation to the Mondrian visualization engine. The only parameter it takes is a painting block to which it passes an instance of a ViewRenderer.

Instance Variables
	painting:		aBlock that takes a ViewRenderer as the first parameter!

!GLMMondrianPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/24/2010 01:12'!
canvas
	^ canvas! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/24/2010 01:12'!
canvas: anObject
	canvas := anObject! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting 
	 
	^painting! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting: anObject 
	 
	painting := anObject! !

!GLMMondrianPresentation methodsFor: 'rendering' stamp: 'tg 1/18/2010 21:27'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^aRenderer renderMondrianPresentation: self! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: 'TudorGirba 12/24/2010 01:12'!
renderOn: aView
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self painting glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aView with: self entity with: self]).
	self canvas: aView canvas! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:05'!
view
	^ view ifNil: [view := MOViewRenderer new]! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: 'tg 4/1/2010 10:38'!
view: anObject
	view := anObject! !

GLMPresentation subclass: #GLMRoassalPresentation
	instanceVariableNames: 'painting view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Mondrian-Presentations'!

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
canvas
	 ^ canvas! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
canvas: anObject
	canvas := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:03'!
painting	 
	^painting! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
painting: anObject 	 
	painting := anObject! !

!GLMRoassalPresentation methodsFor: 'rendering' stamp: 'FelipeGonzlezMartnez 12/21/2011 21:36'!
renderOn: aView
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self painting glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aView with: self entity with: self]).
	self canvas: aView view! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:26'!
view
	^ view ifNil: [view := ROView new]! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:26'!
view: anObject
	view := anObject! !

!MOViewRenderer methodsFor: '*glamour-mondrian-presentations' stamp: 'TudorGirba 7/19/2011 13:15'!
asBrowserWithStatusbar
	| browser |
	browser := GLMTabulator withStatusbar.
	browser title: 'Mondrian painting'.
	browser column: #painting.
	browser 
			act: [:b | (b paneNamed: #painting) presentations first canvas exportAsPNG] entitled: 'Export as PNG';
			act: [:b | 
				(b paneNamed: #painting) presentations first canvas root decreaseZoom.
				(b paneNamed: #painting) presentations first canvas changed ] 
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
			act: [:b | 
				(b paneNamed: #painting) presentations first canvas root increaseZoom.
				(b paneNamed: #painting) presentations first canvas root updateWindow ] 
			icon: MondrianIcons mondrianZoomIn 
			entitled: 'Zoom in'.
	browser transmit to: #painting; andShow: [ :a | 
		a mondrian view: self ].
	^ browser! !

!MOViewRenderer methodsFor: '*glamour-mondrian-presentations' stamp: 'TudorGirba 7/19/2011 13:15'!
openWithStatusbar
	^ self asBrowserWithStatusbar openOn: self! !
